import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * Write a description of class Table here.
 * 
 * @author 高慧君
 * @version (2012/06/16)
 */
public class Table extends World
{
    public ArrayList<Light> lights = new ArrayList<Light>();

    public int level = 0;
    public int levels = 5;   //總關數
    public static  int bulb[][][]= {
            {{-1,-1,1,1},   // level 1
                {-1,1,1,1},
                {1,1,1,1},
                {1,1,1,1} }, 

            {{1,1,1,1},   // level 2
                {1,1,-1,1},
                {1,-1,-1,1},
                {1,1,1,-1} }, 

            {{1,1,-1,1},   // level 3
                {1,1,-1,-1},
                {-1,-1,1,1},
                {1,-1,1,1} },                                 

            {{1,-1,-1,1},   // level 4
                {-1,-1,-1,-1},
                {-1,-1,-1,-1},
                {1,-1,-1,1} }, 

            {{1,-1,-1,-1},   // level 5
                {1,-1,1,1},
                {1,1,-1,1},
                {-1,-1,-1,1}}
        };

    public Level levelText= new Level();
    public boolean playing=true;
    /**
     * Constructor for objects of class Table.
     * 
     */
    public Table()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(4, 5, 60);
        Screen screen = new Screen();
        addObject(screen, 1, 1);
        screen.setImage("blankStart.gif");
        Greenfoot.start();
    }

    public void act() {
        int sum = 0;
        for (Light light: lights) {
            sum += light.status;   
        }

        if (playing) {
            if (sum == 16) {
                addObject(new Screen(), 1, 1);
                for (Light light: lights) {
                    removeObject(light);
                }
                removeObject(levelText);
                lights.clear();
                playing = false;
            }
        }
            GreenfootImage levelImage = levelText.getImage();
            levelImage.clear();
            levelImage.scale(100, 30);
            levelImage.drawString("第"+level+"關", 10, 10);

    }

    public void nextLevel() {
        if (level==levels) {
            Screen screen = new Screen();
            addObject(screen, 1, 1);
            screen.setImage("blankEnd.gif");         
            Greenfoot.stop();
        } else {
            addObject(levelText, 2, 5);
            level++;
            for (int i=0; i<4; i++) {
                for (int j=0; j<4; j++) {
                    Light light = new Light(bulb[level-1][j][i]);
                    addObject(light, i, j);
                    lights.add(light);
                }
            }        
            playing = true;
        }

    }
}
